/*
   GoToSocial
   Copyright (C) 2021-2022 GoToSocial Authors admin@gotosocial.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU Affero General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Affero General Public License for more details.

   You should have received a copy of the GNU Affero General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// Package docs GoToSocial
//
// GoToSocial Swagger documentation.
//
//     Schemes: https, http
//     BasePath: /
//     Version: REPLACE_ME
//     Host: example.org
//     License: AGPL3 https://www.gnu.org/licenses/agpl-3.0.en.html
//     Contact: GoToSocial Authors <admin@gotosocial.org>
//     SecurityDefinitions:
//       OAuth2 Bearer:
//         type: oauth2
//         flow: accessCode
//         authorizationUrl: https://example.org/oauth/authorize
//         tokenUrl: https://example.org/oauth/token
//         scopes:
//           read: grants read access to everything
//           read:accounts: grants read access to accounts
//           read:blocks: grant read access to blocks
//           read:custom_emojis: grant read access to custom_emojis
//           read:media: grant read access to media
//           read:search: grant read access to searches
//           read:statuses: grants read access to statuses
//           read:streaming: grants read access to streaming api
//           read:user: grants read access to user-level info
//           read:notifications: grants read access to notifications
//           write: grants write access to everything
//           write:accounts: grants write access to accounts
//           write:blocks: grants write access to blocks
//           write:follows: grants write access to follows
//           write:media: grants write access to media
//           write:statuses: grants write access to statuses
//           write:user: grants write access to user-level info
//           admin: grants admin access to everything
//           admin:accounts: grants admin access to accounts
//       OAuth2 Application:
//         type: oauth2
//         flow: application
//         tokenUrl: https://example.org/oauth/token
//         scopes:
//           write:accounts: grants write access to accounts
//
// swagger:meta
package docs
